#ifdef __cplusplus
extern "C" {
void abort(void);
#endif
void main(void);
#ifdef __cplusplus
}
#endif


#include<36064s.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "vs-wrc003+encoder.h"
#include "sciflash.h"
#include "memmap.h"

#define I_Time 12
//O[oϐ
volatile double GYCenter;		//WC_
volatile int AdBuff[I_Time];	//WCZTpobt@

volatile double angle;			//px
volatile double dangle;			//ex
volatile double z;				//ړ
volatile double dz;				//ړx
volatile double dzave;			//ړx
volatile double iz;				//ړϕ

volatile unsigned char memmap[MEMMAP_SIZE];	//QCȂǂ̃}bv
extern const unsigned char map[64];			//}bv}bvl
unsigned char GYch = 0;

double getAdAve(int size){
	int i;
	double temp = 0;
	for(i=0 ;i<size;i++){
		temp+=(double)AdBuff[i];
	}
	return temp/(double)size - GYCenter;
}

void setAdBuf(){
	int i;
	for(i = I_Time-1 ; i>0 ; i--){
		AdBuff[i] = AdBuff[i-1];
	}
	AdBuff[0] = AdRead(GYch);
}

void main(void)
{
//ϐ
	BYTE mtr[2] = {0x80,0x80};	//[^o
	BYTE mode = 0;				//샂[hi0FLu[VA1FJnj
	
	const BYTE MainCycle = 120;	//C[vg
	double vec_z[10];			//ړobt@iߋ10j
	double vec_zave[5];			//ړ̕ϒlpobt@iߋ5j
	double out;					//o͒l@Z
	double GYCenterTemp;		//WC_ޔp
	double *vec_Gain;			//eQCz
	BYTE LineMode = 0;
	
	double fwvalue = 1.0; 		//Oړ̈ʒup
	unsigned long fwcnt = 0;	//Oړ̎ԑp
	
	int i=0;					//ėp
	int MaxPowerCntCW = 0;		//SJԑpivj
	int MaxPowerCntCCW = 0;		//SJԑpivj
	
//ݒ
	Init((BYTE)MainCycle);
	InitSci3(CBR_115200,even,1);
	BuzzerSet(0x80,0x80);
	LED(1);
	Mtr_Run(0,0,0,0);

//N҂ 
	for(i=0;i<10;i++)
		Sync();
	
	//VS-SB001̐ڑ|[gmFB
	//2011.05ȍ~oו́AAN2ɐڑB
	#define AD_OFF 4080
	while(1){
		unsigned int ad0,ad1;
		ad0 = AdRead(0); 
		ad1 = AdRead(1); 
		if(ad0 > AD_OFF && ad1 > AD_OFF){
			unsigned char breakflag = 0;
			while(1){
				int z = 0;
				BuzzerStart();
				for(z = 0 ; z < 10 ; z++){
					Sync();
					if(getSW()){
						while(getSW());
						breakflag = 1;
						break;
					}
				}
				BuzzerStop();
				for(z = 0 ; z < 10 ; z++){
					Sync();
					if(getSW()){
						while(getSW());
						breakflag = 1;
						break;
					}
				}
				if(breakflag > 0)
					break;
			}
		}
		else if(ad0 > AD_OFF){
			GYch = 1;
			break;	
		}
		else if(ad1 > AD_OFF){
			GYch = 0;
			break;	
		}
	}
	BuzzerSet(0x80,0x80);
	for(i = 0 ; i < 10 ; i++)
		setAdBuf();
	
//QCȂǓǍ
	Rd_MEMMAP();
	vec_Gain = (double*)&memmap[GAIN_MAP];


//C[v
	while(1){
		setAdBuf();	
		setAdBuf();
		setAdBuf();
		Sync();
		setAdBuf();
		setAdBuf();
		setAdBuf();
		setAdBuf();	
		LED(2);
		
	//Lu[V[h
		if(mode == 0){
			int n;
			double tempValue = 0.0;
		
		//WCSݒpuU[
			tempValue = (getAdAve(7)/4094.0)*3.3;
			if((tempValue > 0.5 )&& (tempValue < 2.8)){
				BuzzerStop();
			}
			else if(isBuzzer()==0){
				BuzzerStart();
			}
		//{^ꂽWC̃Lu[V
			if(getSW()){
				BuzzerStop();
				LED(1);
				Sync();
				tempValue = 0.0;
				for(n =0;n<150;n++){
					tempValue += (double)AdRead(GYch);
					Sync();
				}
		
				GYCenter = (tempValue/150.0);
				tempValue = 0;
		
				for(n = 0;n<I_Time;n++)
					AdBuff[n] = GYCenter;
				for(i=0;i<10;i++)
					vec_z[i] = 0.0;
				for(i=0;i<5;i++)
					vec_zave[i] = 0.0;
				angle = 0;
				ClearZ();
				GYCenterTemp = GYCenter;
				mode = 1;
				LineMode = 0;
				
				BuzzerStart();
				Wait(100);
				BuzzerStop();
			}
		}
	
		
	//s[h
		else if(mode == 1){
			if(getSW()){
				LED(1);
				angle = 0.0;
				z = 0.0;
				dangle = 0.0;
				dz = 0.0;
				iz = 0.0;
				ClearZ();
				GYCenter = GYCenterTemp;
				fwvalue = 0.0;
				fwcnt = 0;
				LineMode = 0;
			}
		
	//ZTl擾Ael̎Zo
			dangle = (((double)getAdAve(7))*-3.3/(4096.0*0.0067));	// 6.7mv/deg/sec, 3.3v = 4096
			
			if(GYch == 1){	//VS-SB001B@ύX
				dangle *= 2.0;
			}
			angle += dangle/MainCycle;
			z = (double)GetZ()*360.0/(27.0*4.0);
			iz += z;
			for(i = 9;i>0;i--){
				vec_z[i] = vec_z[i-1];
			}
			vec_z[0] = z;
			dz = (z - vec_z[1])*MainCycle;


	//Oړ̂߂̏iz炷j
			if(memmap[RUN_MODE] == 1){	
				z -= fwvalue;
				if(fwcnt < (unsigned long)MainCycle*memmap[GAIN_TIME] - MainCycle/6){
					BuzzerStop();
					fwvalue += (double)memmap[GAIN_SPD]/((double)MainCycle);
					fwcnt++;
				}
				else if(fwcnt < (unsigned long)MainCycle*memmap[GAIN_TIME]){
					fwcnt++;
					BuzzerStart();
				}
				else if(fwcnt < (unsigned long)MainCycle*memmap[GAIN_TIME] * 2 - MainCycle/6){
					BuzzerStop();
					fwvalue -= (double)memmap[GAIN_SPD]/((double)MainCycle);
					fwcnt++;
				}
				else if(fwcnt < (unsigned long)MainCycle*memmap[GAIN_TIME] * 2){
					fwcnt++;
					BuzzerStart();
				}
				else{
					fwcnt = 0;
					fwvalue = 0.0;
				}
			}
			//ړ␳iX^[gʒuɖ߂邽߂̏j
			if(z >= 0.0)			
				GYCenter += z*z*0.000001;
			else
				GYCenter -= z*z*0.000001;


	//GR[_ωFPmm
			for(i = 4;i>0;i--){
				vec_zave[i] = vec_zave[i-1];
			}
	
			dzave=0.0;
			for(i=0;i<10;i++){
				dzave += vec_z[i];
			}
			vec_zave[0] = dzave/10.0;
	
			dzave = (vec_zave[0] - vec_zave[1])*MainCycle;


	//o͒lݒ
			out = vec_Gain[GAIN_EN_P]*z 		//P ړ@iGR[_j
				+ vec_Gain[GAIN_EN_D]*dzave 	//D@x@iGR[_j
				+ 0.0020*iz 					//I@ړ̐ϕiGR[_j
				+ vec_Gain[GAIN_GY_P]*angle 	//P@pxiWCj
				+ vec_Gain[GAIN_GY_D]*dangle;	//D@pxiWCj
			
	//e[^̃I[o[t[`FbNAo͐ݒ
			if(out>=0.0){
				long OutPutTemp = 0;
				OutPutTemp = (long)(out);
				if(OutPutTemp>127)
					OutPutTemp = 127;
				mtr[0] = (BYTE)OutPutTemp;
				mtr[1] = (BYTE)(0x100 - OutPutTemp);
			}
			else{
				long OutPutTemp = 0;
				OutPutTemp = -(long)(out);
				if(OutPutTemp>127)
					OutPutTemp = 127;
				mtr[0] = (BYTE)(0x100 - OutPutTemp);
				mtr[1] = (BYTE)OutPutTemp;
			}
	//]|oiō1bj
			if(mtr[1] == 0x7F)
				MaxPowerCntCW++;
			else 
				MaxPowerCntCW = 0;
			if(mtr[1] == 0x81)
				MaxPowerCntCCW++;
			else 
				MaxPowerCntCCW = 0;
	//]|̒~[v
			if(MaxPowerCntCW > MainCycle || MaxPowerCntCCW > MainCycle ){
				Mtr_Run(0,0,0,0);
				while(!getSW());
				while(!getSW());
				angle = 0.0;
				z = 0.0;
				dangle = 0.0;
				dz = 0.0;
				iz = 0.0;
				ClearZ();
			}
	//[^o
			else 
				Mtr_Run(mtr[1],mtr[1],0,0);
		}
	}
}

#ifdef __cplusplus
void abort(void)
{
	
}
#endif
